Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation

<DefaultClassOptions(), NavigationItem(False), CreatableItem(False)> _
Public Class InvoiceFactoringHeader 'Faktorálási engedményezési szerződés
    Inherits BaseObject

    Private _DocumentNumber As String 'A bank által jóváhagyott sorszám
    Private _ContractFile As FileData 'A bank által visszaküldött engedményezési szerződés
    Private _Description As String 'Egyéb megjegyzés
    Private _DateExecution As Date 'Dátum
    Private _InterestPercent As Double ' faktor kamat

    Private _SpreadXML As String
    Private _SpreadFile As FileData
    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        ' Place here your initialization code.
    End Sub

    Property DocumentNumber As String
        Get
            Return _DocumentNumber
        End Get
        Set(value As String)
            SetPropertyValue("DocumentNumber", _DocumentNumber, value)
        End Set
    End Property
    Property ContractFile As FileData
        Get
            Return _ContractFile
        End Get
        Set(value As FileData)
            SetPropertyValue("ContractFile", _ContractFile, value)
        End Set
    End Property
    <Size(-1)> _
    Property Description As String
        Get
            Return _Description
        End Get
        Set(value As String)
            SetPropertyValue("Description", _Description, value)
        End Set
    End Property
    Property DateExecution As Date
        Get
            Return _DateExecution
        End Get
        Set(value As Date)
            SetPropertyValue("DateExecution", _DateExecution, value)
        End Set
    End Property
    Property InterestPercent As Double
        Get
            Return _InterestPercent
        End Get
        Set(value As Double)
            SetPropertyValue("InterestPercent", _InterestPercent, value)
        End Set
    End Property

    <Size(-1)> _
    Property SpreadXML As String
        Get
            Return _SpreadXML
        End Get
        Set(value As String)
            SetPropertyValue("SpreadXML", _SpreadXML, value)
        End Set
    End Property
    Property SpreadFile As FileData
        Get
            Return _SpreadFile
        End Get
        Set(value As FileData)
            SetPropertyValue("SpreadFile", _SpreadFile, value)
        End Set
    End Property


    <Association("InvoiceFactoringHeader-InvoiceFactoringRows", GetType(InvoiceFactoringRows)), VisibleInListView(False), VisibleInLookupListView(False)> _
    ReadOnly Property InvoiceFactoringRows As XPCollection(Of InvoiceFactoringRows)
        Get
            Return GetCollection(Of InvoiceFactoringRows)("InvoiceFactoringRows")
        End Get
    End Property
End Class
